package com.demo.mybatis;

import java.util.HashMap;
import java.util.Map;

import org.apache.ibatis.session.SqlSession;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class MyBatisRepository implements Repository {

	public MyBatisRepository() {

	}

	public MyBatisRepository(SqlSession sqlSession, String nameSpace, String tableName) {
		this.sqlSession = sqlSession;
		this.nameSpace = nameSpace;
		this.tableName = tableName;
	}

	@Override
	public void create() {
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tableName", tableName);

		logger.debug("param:{}", param);

		String mappersql = nameSpace + "." + CREATE;
		sqlSession.update(mappersql, param);
	}

	@Override
	public int insert(Map<String, Object> data) {
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tableName", tableName);
		param.put("data", data);

		logger.debug("param:{}", param);
		logger.debug("data:{}", data);

		String mappersql = nameSpace + "." + INSERT;
		return sqlSession.insert(mappersql, param);
	}

	@Override
	public int update(Map<String, Object> data) {
		Map<String, Object> param = new HashMap<String, Object>();
		param.put("tableName", tableName);
		param.put("data", data);

		logger.debug("param:{}", param);
		logger.debug("data:{}", data);

		String mappersql = nameSpace + "." + UPDATE;
		return sqlSession.update(mappersql, param);
	}

	public SqlSession getSqlSession() {
		return sqlSession;
	}

	public void setSqlSession(SqlSession sqlSession) {
		this.sqlSession = sqlSession;
	}

	public String getNameSpace() {
		return nameSpace;
	}

	public void setNameSpace(String nameSpace) {
		this.nameSpace = nameSpace;
	}

	public String getTableName() {
		return tableName;
	}

	public void setTableName(String tableName) {
		this.tableName = tableName;
	}

	public static final String CREATE = "create";
	public static final String INSERT = "insert";
	public static final String UPDATE = "update";

	private SqlSession sqlSession;
	private String nameSpace;
	private String tableName;
	private final Logger logger = LogManager.getLogger();
}
